package hu.bme.mit.jdt.info.handlers;

import hu.bme.mit.jdt.info.visitors.MethodVisitor;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.ASTParser;
import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jdt.core.dom.MethodDeclaration;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.handlers.HandlerUtil;

public class MethodInfoHandler extends AbstractHandler implements IHandler {

	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {
		IStructuredSelection selection = (IStructuredSelection) HandlerUtil
				.getCurrentSelection(event);
		ICompilationUnit unit = (ICompilationUnit) selection.getFirstElement();
		MethodVisitor visitor = new MethodVisitor();
		CompilationUnit unitAST = parse(unit);
		unitAST.accept(visitor);
		for (MethodDeclaration method : visitor.getMethods()) {
			System.out.println("Method name: " + method.getName().getFullyQualifiedName() + " Return type: " + method.getReturnType2());
		}
		return null;
	}

	private CompilationUnit parse(ICompilationUnit unit) {
		ASTParser parser = ASTParser.newParser(AST.JLS3);
		parser.setKind(ASTParser.K_COMPILATION_UNIT);
		parser.setSource(unit);
		parser.setResolveBindings(true);
		return (CompilationUnit) parser.createAST(null);
	}
}
